<?php
	/*
	* Functions file
	* (c) 2009 PART3
	*/

	function _GET( $var )
	{
		return rmslashes( $_GET[ $var ] );
	}
	
	function _POST( $var )
	{
		return rmslashes( $_POST[ $var ] );
	}
	
	function rmslashes( $str )
	{
		return get_magic_quotes_gpc() ? stripslashes( $str ) : $str;
	}
	
	// Load configuration from file
	function load_conf()
	{
		global $conf;
		
		if ( !file_exists( APP_ROOT . 'config.php' ) )
		{
			die( 'Config file is missing.' );
		}
		
		$conf = include( APP_ROOT . 'config.php' );		
		$conf = array_merge( $conf, array(
			'smarty_template_dir' => 'templates',
			'smarty_compile_dir'  => 'templates_c',
			'smarty_cache_dir'    => 'cache',
			'smarty_config_dir'   => 'configs'
		));
		
		if ( !file_exists( APP_ROOT . $conf['smarty_lib_path'] ) )
		{
			die( 'Smarty lib is missing.' );
		}
	}
	
	// Load extended configuration from db.
	function load_dbconf() {
		global $econf, $db, $dbprefix;
		
		$result = $db->query( "SELECT * FROM `{$dbprefix}etc`" );
		if ( $result->num_rows > 0 ) {
			while ( $row = $result->fetch_object() ) {
				$econf[ $row->name ] = $row->value;
			}
			$result->free_result();
		}
	}
	
	// Check login
	function check_login( $RenewSession = true )
	{
		global $econf;
		if ( !isset( $econf ) )
		{
			load_dbconf();
		}
		
		$AdminUser = $econf[ 'admin_user' ];
		$AdminHash = $econf[ 'admin_hash' ];
		$AdminCookie_U = $econf[ 'admin_cookie' ] . '_u';
		$AdminCookie_K = $econf[ 'admin_cookie' ] . '_k';
		
		if ( !isset( $_COOKIE[ $AdminCookie_U ] )
			|| !isset( $_COOKIE[ $AdminCookie_K ] )
			|| $_COOKIE[ $AdminCookie_U ] != $AdminUser )
		{
			return false;
		}		
		if ( $_COOKIE[ $AdminCookie_K ] == md5( $AdminHash ) )
		{
			if ( $RenewSession )
			{
				set_logon_cookie( true );
			}
		
			return true;
		}		
		return false;
	}
	
	function set_logon_cookie( $On )
	{
		global $econf;
		if ( !isset( $econf ) )
		{
			load_dbconf();
		}
		
		$AdminUser = $econf[ 'admin_user' ];
		$AdminHash = $econf[ 'admin_hash' ];
		$AdminCookie_U = $econf[ 'admin_cookie' ] . '_u';
		$AdminCookie_K = $econf[ 'admin_cookie' ] . '_k';
		
		if ( $On )
		{
			setcookie( $AdminCookie_U, $AdminUser, time() + 14400, '/' );
			setcookie( $AdminCookie_K, md5( $AdminHash ), time() + 14400, '/' );
			
			return;
		}
		
		setcookie( $AdminCookie_U, '', time() - 3600, '/' );
		setcookie( $AdminCookie_K, '', time() - 3600, '/' );
	}
	
	// Hash
	// Now is plain SHA1
	function z_hash( $str )
	{
		return sha1( $str );
	}
	
	// Redirect
	function redirect( $URL )
	{
		header( 'Location: ' . $URL );
		exit;
	}
	
	// Get like url
	function get_like_url( $id ) {
		global $econf;
		
		$page = '/like.php?l=';
		if ( $econf[ 'pretty_urls' ] ) {
			$page = '/like/';
		}
		return $econf[ 'site_url' ] . $page . $id;
	}
	
	// cut and add "..." if title exceeds X chars
	function like_text_truncate( $text, $chars = -1 ) {
		global $econf;
		$m = ( $chars == -1 ) ? $econf[ 'max_list_chars' ] : $chars;
		mb_internal_encoding( 'UTF-8' );
		
		if ( mb_strlen( $text ) > $m ) {
			return mb_substr( $text, 0, $m ) . '...';
		}
		return $text;
	}
	
	// Get page url
	function get_page_url( $id, $pretty_name = '' ) {
		global $econf;
		
		$page = '/page.php?p=';
		if ( $econf[ 'pretty_urls' ] ) {
			if ( !empty( $pretty_name ) ) {
				$id = $pretty_name;
			}
			$page = '/page/';
		}
		return $econf[ 'site_url' ] . $page . $id;
	}
	
	// Get file url
	function get_file_url( $file ) {
		global $econf;
		return $econf[ 'site_url' ] . '/data/' . $file;
	}
	
	// Get Like
	function get_Like_Listing( $type, $text, $title = '' ) {
		if ( $type == 2 ) {
			return get_yt_image( $text, $title );
		}
		if ( $type == 1 ) {
			return get_like_image( $text, 'small', $title );
		}
		return like_text_truncate( $text );
	}
	
	// Get actual like
	function get_Like( $type, $text ) {
		if ( $type == 2 ) {
			return get_yt_embed( $text );
		}
		if ( $type == 1 ) {
			return get_like_image( $text, 'big' );
		}
		return $text;
	}
	
	// Get Like page title
	function get_Like_Title( $type, $text, $id = 0, $title = '' ) {
		global $db, $dbprefix;
		if ( $type == 2 ) {
			if ( $title == '' ) {
				$title = get_yt_title( $text );
				if ( $id != 0 ) {
					// update the database
					$db->query( "UPDATE `{$dbprefix}likes` SET `title`='%s' WHERE `id`='$id'", $title );
				}
			}
			return $title;
		}
		if ( $type == 1 ) {
			if ( $title == '' ) {
				$title = $text;
			}
			return like_text_truncate( $title );
		}
		return like_text_truncate( br2space( $text ) );
	}
	
	// Get Like ogimage
	function get_Like_ogimage( $type, $text ) {
		if ( $type == 2 ) {
			return 'http://img.youtube.com/vi/' . $text . '/2.jpg';
		}
		if ( $type == 1 ) {
			return $text;
		}
		return false;
	}
	
	// YT Small Image
	function get_yt_image( $id, $title = '' ) {
		global $econf;
		$playimg = ( $econf[ 'pretty_urls' ] ) ? $econf[ 'site_subdir' ] . '/images/play_video.png' : 'images/play_video.png';
		$extratitle = ( $title != '' ) ? " &quot;{$title}&quot;" : '';
		$extratitle_bottom = ( $title != '' ) ? "<div style=\"padding-top:3px;\">&quot;{$title}&quot;</div>" : '';
		return '<div title="Play video" style="background:url(\'http://img.youtube.com/vi/' . $id . '/2.jpg\') no-repeat left top;width:120px;height:90px;"><img style="margin-left:44px;margin-top:29px;" src="' . $playimg . '" alt="Play video' . $extratitle . '" title="Play video' . $extratitle . '" /></div>' . $extratitle_bottom;
	}
	
	// YT Embed
	function get_yt_embed( $id ) {
		return '<object width="480" height="385">
		<param name="wmode" value="opaque" />
		<param name="movie" value="http://www.youtube.com/v/' . $id . '?fs=1&amp;hl=en_US"></param>
		<param name="allowFullScreen" value="true"></param><param name="allowscriptaccess" value="always"></param>
		<embed wmode="opaque" src="http://www.youtube.com/v/' . $id . '?fs=1&amp;hl=en_US" type="application/x-shockwave-flash" allowscriptaccess="always" allowfullscreen="true" width="480" height="385"></embed>
		</object>';
	}
	
	// Image like get image
	function get_like_image( $link, $size, $title = '' ) {
		if ( $title != '' ) {
			$title = '<br />&quot;' . $title . '&quot;';
		}
		if ( $size == 'small' ) {
			return '<img src="' . $link . '" alt="Image" style="max-width:390px;max-height:100px;" />' . $title;
		}
		return '<img src="' . $link . '" alt="Image" style="max-width:500px;max-height:600px;" />';
	}
	
	// Get YT Video Title
	function get_yt_title( $id ) {
		$feedURL = 'http://gdata.youtube.com/feeds/api/videos/'. $id; 
		
        $ch = curl_init();
        curl_setopt( $ch, CURLOPT_URL, $feedURL );
        curl_setopt( $ch, CURLOPT_RETURNTRANSFER, 1 );
        curl_setopt( $ch, CURLOPT_TIMEOUT, 4 );
        $result = curl_exec( $ch );
		
        $entry = simplexml_load_string( $result );
		$media = $entry->children('http://search.yahoo.com/mrss/');
		
		return stripslashes( $media->group->title );
    }
	
	// <br /> to space
	function br2space( $str ) {
		return preg_replace( '/<br[^>]*>/', ' ', $str );
	}
?>