<?php
	define( 'APP_ROOT', './' );
	require( APP_ROOT . 'world.php' );
	
	$vars = array();
	$rows = array();
	
	$RecentLimit = $econf[ 'max_recent' ];
	$result = $db->query( "SELECT * FROM `{$dbprefix}likes` ORDER BY `time` DESC LIMIT $RecentLimit" );
	if ( $result->num_rows > 0 )
	{
		while ( $row = $result->fetch_object() )
		{
			$rows['LIKES_RECENT'][] = array(
				'id' => $row->id,
				'text' => get_Like_Listing( $row->type, $row->text, $row->title ),
				'url' => get_like_url( $row->id ),
				'url_enc' => urlencode( get_like_url( $row->id ) ),
			);
		}
		$result->free_result();
	}

	$TrendingLimit = $econf[ 'max_trending' ];
	$OneDayAgo = time() - 24 * 60 * 60;
	$result = $db->query( "SELECT `l`.*, SUM(`t`.`count`) AS `c` FROM `{$dbprefix}tracking` `t` LEFT JOIN `{$dbprefix}likes` `l` ON `t`.`like_id` = `l`.`id` WHERE `t`.`time`>='$OneDayAgo' GROUP BY `like_id` ORDER BY `c` DESC, `like_id` DESC LIMIT $TrendingLimit" );
	if ( $result->num_rows > 0 )
	{
		while ( $row = $result->fetch_object() )
		{
			$rows['LIKES_TRENDING'][] = array(
				'id' => $row->id,
				'text' => get_Like_Listing( $row->type, $row->text, $row->title ),
				'url' => get_like_url( $row->id ),
				'url_enc' => urlencode( get_like_url( $row->id ) ),
			);
		}
		$result->free_result();
	}
	
	$PopularLimit = $econf[ 'max_popular' ];
	$result = $db->query( "SELECT * FROM `{$dbprefix}likes` ORDER BY `liked`+`shared` DESC LIMIT $PopularLimit" );
	if ( $result->num_rows > 0 )
	{
		while ( $row = $result->fetch_object() )
		{
			$rows['LIKES_POPULAR'][] = array(
				'id' => $row->id,
				'text' => get_Like_Listing( $row->type, $row->text, $row->title ),
				'url' => get_like_url( $row->id ),
				'url_enc' => urlencode( get_like_url( $row->id ) ),
			);
		}
		$result->free_result();
	}
	
	$RandomLimit = $econf[ 'max_random' ];
	$result = $db->query( "SELECT * FROM `{$dbprefix}likes` ORDER BY RAND() LIMIT $RandomLimit" );
	if ( $result->num_rows > 0 )
	{
		while ( $row = $result->fetch_object() )
		{
			$rows['LIKES_RANDOM'][] = array(
				'id' => $row->id,
				'text' => get_Like_Listing( $row->type, $row->text, $row->title ),
				'url' => get_like_url( $row->id ),
				'url_enc' => urlencode( get_like_url( $row->id ) ),
			);
		}
		$result->free_result();
	}
	
	$vars = array_merge( $vars, array(
		'BLOCKS_ORDER'	=> explode( ',', $econf[ 'blocks_order' ] ),
	));
	
	
	$tpl->assign( $vars );
	$tpl->assign( $rows );
	$tpl->display( 'index.html' );
?>
