<?php
	define( 'APP_ROOT', './' );
	require( APP_ROOT . 'world.php' );
	$vars = array();
	
	// Get the GET data
	$Type		= urldecode( _GET( 't' ) );
	$Keywords	= urldecode( _GET( 'k' ) );
	$Page		= (int)_GET( 'p' );
	
	// Process type, if present
	$TypeNumeric = -1;
	$AcceptableTypes = array( 'type:text', 'type:image', 'type:youtube' );
	$WhereType = '';
	$WhereTypeSpecial = '';
	if ( in_array( $Type, $AcceptableTypes ) ) {
		if ( $Type == 'type:text' ) {
			$TypeNumeric = 0;
		}
		if ( $Type == 'type:image' ) {
			$TypeNumeric = 1;
		}
		if ( $Type == 'type:youtube' ) {
			$TypeNumeric = 2;
		}
		$WhereType 			= "AND `type` = '$TypeNumeric'";
		$WhereTypeSpecial	= "WHERE `type` = '$TypeNumeric' ";
	} else {
		$Type = '';
	}
	
	// Mode, process keywords if present
	$Special = false;
	if ( $Keywords == 'special:recent' || $Keywords == 'special:popular' || $Keywords == 'special:random' || $Keywords == 'special:trending' ) {
		$Special = true;
		$SpecialMode = $Keywords;
	}
	if ( !empty( $Keywords ) && !$Special ) {
		$Keywords = $db->sanitize( trim( $Keywords ) );
	}
	
	// Get the number of results
	$Where = " WHERE `text` LIKE '%$Keywords%' $WhereType";
	if ( $Special ) {
		$Where = " $WhereTypeSpecial";
		if ( $SpecialMode == 'special:trending' ) {
			$OneDayAgo = time() - ( 24 * 60 * 60 );
			$ConnectorWord = 'AND';
			if ( empty( $WhereTypeSpecial ) ) {
				$ConnectorWord = 'WHERE';
			}
			$Where .= " $ConnectorWord `last_liked_at` >= '$OneDayAgo'";
		}
	}
	$result = $db->query( "SELECT COUNT(*) AS `count` FROM `{$dbprefix}likes`$Where" );
	$row = $result->fetch_object();
	$results_total = $row->count;
	$result->free_result();
	
	// Order part:
	$byOrder = "WHERE LOWER(`text`) LIKE LOWER('%$Keywords%') $WhereType ORDER BY `id` DESC";
	if ( $Special ) {
		switch ( $SpecialMode ) {
			default:
			case 'special:recent':
				$byOrder = "ORDER BY `id` DESC";
				break;
			case 'special:popular':
				$byOrder = "ORDER BY `liked`+`shared` DESC";
				break;
			case 'special:random':
				$byOrder = "ORDER BY RAND()";
				break;
			case 'special:trending':
				$byOrder = "ORDER BY `last_liked_at` DESC";
				break;
		}
		$byOrder = $WhereTypeSpecial . $byOrder;
	}
	
	// Query the database and get results
	$MaxResult = $econf[ 'max_search_results' ];
	$limit = ( $results_total > $MaxResult ) ? ( $Page > 1 ) ? 'LIMIT ' . ( $Page - 1 ) * $MaxResult . ', ' . $MaxResult : 'LIMIT ' . $MaxResult : '';
	if ( $Special && $SpecialMode == 'special:random' ) {
		$limit = 'LIMIT ' . $MaxResult;
		$results_total = 1;
	}
	$result = $db->query( "SELECT * FROM `{$dbprefix}likes` $byOrder $limit" );
	if ( $result->num_rows > 0 )
	{
		$results = array();
		$results_num = $result->num_rows;
		
		while ( $row = $result->fetch_object() )
		{
			$results[] = array(
				'id' => $row->id,
				'text' => get_Like_Listing( $row->type, $row->text, $row->title ),
				'url' => get_like_url( $row->id ),
				'url_enc' => urlencode( get_like_url( $row->id ) ),
			);
		}
		
		$vars = array(
			'RESULTS'			=> $results,
		);
		
		$result->free_result();
	}
	
	$vars = array_merge( $vars, array(
			'RESULTS_NUM'	=> ( isset( $results_num ) ) ? $results_num : 0,
			'S_PAGES'		=> ( $results_total % $MaxResult > 0 ) ? floor( $results_total / $MaxResult + 1 ) : $results_total / $MaxResult,
			'S_PAGES_CUR'	=> ( $Page > 0 ) ? $Page : 1,
			'SPECIAL'		=> $Special,
			'SPECIALMODE'	=> $SpecialMode,
			'TYPE'			=> $Type,
			'TYPE_NUMERIC'	=> $TypeNumeric,
			'KEYWORD'		=> ( empty( $Keywords ) ) ? urlencode( '_' ) : urlencode( $Keywords ),
			'KEYWORD_CLEAN'	=> $Keywords,
	));
	$tpl->assign( $vars );
	$tpl->display( 'search.html' );
?>
