<?php
	/*
	* LikeList
	* Common include "World"
	* (c) 2010 PART3
	*/
	
	// Check for register_globals.
	if ( ini_get( 'register_globals' ) )
	{
		die( 'You have register_globals turned on. I refuse to run.' );
	}

	// Includes and config loading.
	require_once( APP_ROOT . 'includes/functions.php' );
	load_conf();
	require_once( APP_ROOT . 'includes/database.php' );
	require_once( APP_ROOT . $conf['smarty_lib_path'] );

	// Initialization section. Set up DB, Templates, etc.
	// Database is created only if $no_database is either false or not defined.
	if ( !isset( $no_database )
		&& $no_database == false )
	{
		$db = new Database();
	}
	load_dbconf();
	
	$tpl = new Smarty();
	$tpl->template_dir = APP_ROOT . $conf[ 'smarty_template_dir' ];
	$tpl->compile_dir = APP_ROOT . $conf[ 'smarty_compile_dir' ];
	$tpl->cache_dir = APP_ROOT . $conf[ 'smarty_cache_dir' ];
	$tpl->config_dir = APP_ROOT . $conf[ 'smarty_config_dir' ];
	
	ob_start( 'ob_gzhandler' );
	
	define( '_PRETTY_URLS', $econf[ 'pretty_urls' ] );
	$tpl->assign( '_SITE_NAME', $econf[ 'site_name' ] );
	$tpl->assign( '_SITE_NAME_FB', $econf[ 'site_name_fb' ] );
	$tpl->assign( '_SITE_DESC', $econf[ 'site_desc' ] );
	$tpl->assign( '_SITE_IMAGE', $econf[ 'site_image' ] );
	$tpl->assign( '_SITE_URL', $econf[ 'site_url' ] );
	$tpl->assign( '_SITE_URL_ENC', urlencode( $econf[ 'site_url' ] ) );
	$tpl->assign( '_SITE_SUBDIR', $econf[ 'site_subdir' ] );
	$tpl->assign( '_SITE_DOMAIN', parse_url( $econf[ 'site_url' ], PHP_URL_HOST ) );
	$tpl->assign( '_SITE_FBPAGE', $econf[ 'site_fbpage' ] );
	$tpl->assign( '_SITE_FBPAGE_ENC', urlencode( $econf[ 'site_fbpage' ] ) );
	$tpl->assign( '_PREFER_IFRAME', $econf[ 'prefer_iframe' ] );
	$tpl->assign( '_PRETTY_URLS', _PRETTY_URLS );
	
	$tpl->assign( '_EMAILS_ENABLED', $econf[ 'emails_enabled' ] );
	$tpl->assign( '_EMAILS_CUSTOMTITLE', $econf[ 'emails_customtitle' ] );
	$tpl->assign( '_EMAILS_CUSTOMTEXT', $econf[ 'emails_customtext' ] );
	$tpl->assign( '_ACTIVITY_ENABLED', $econf[ 'activity_enabled' ] );
	$tpl->assign( '_SHOUTBOX_ENABLED', $econf[ 'shoutbox_enabled' ] );
	$tpl->assign( '_RSS_ENABLED', $econf[ 'rss_enabled' ] );
	
	/**
	* Initialize Facebook
	*/
	require_once( APP_ROOT . 'includes/Facebook/facebook.php' );
	$facebook = new Facebook( array(
		'appId'  => $econf[ 'fb_appid' ],
		'secret' => $econf[ 'fb_secret' ],
		'cookie' => true,
	));
	$tpl->assign( array(
		'FB_APPID'	=> $econf[ 'fb_appid' ],
		'FB_ADMINS'	=> $econf[ 'fb_admins' ],
	));
	
	/**
	* Get ads from db and assigns them
	* to the proper template variables
	*/
	$result = $db->query( "SELECT * FROM `{$dbprefix}ads` WHERE `active`='1'" );
	if ( $result->num_rows > 0 )
	{
		while ( $row = $result->fetch_object() )
		{
			$templ_var = 'AD_' . strtoupper( $row->area );
			if ( $row->area == 'custom' ) {
				$templ_var = 'AD_CUSTOM_' . $row->id;
			}
			
			$templ_val = '';
			switch ( $row->type ) {
				case 0:
					$style = '';
					if ( $row->width > 0 && $row->height > 0 ) {
						$style = ' style="width:' . $row->width . 'px;height:' . $row->height . 'px;"';
					}
					$templ_val = '<img src="' . $row->img . '" alt="" ' . $style . '/>';
					if ( strlen( $row->link ) > 0 ) {
						$url = ( _PRETTY_URLS ) ? $econf[ 'site_subdir' ] . '/track/' . $row->id : 'track.php?ad=' . $row->id;
						$templ_val = '<a href="' . $url . '">' . $templ_val . '</a>';
					}
					unset( $style );
					unset( $url );
					break;
				case 1:
					$templ_val = '<object width="' . $row->width . '" height="' . $row->height . '">
						<param name="movie" value="' . $row->img . '">
						<embed src="' . $row->img . '" width="' . $row->width . '" height="' . $row->height . '">
						</embed>
						</object>';
					break;
				case 2:
					$templ_val = $row->html;
					break;
				default:
					break;
			}
			$templ_val = "<div>$templ_val</div>";
			
			$tpl->assign( $templ_var, $templ_val );
			unset( $templ_var );
			unset( $templ_val );
		}
		$result->free_result();
	}
	
	/**
	* Pages
	*/
	$result = $db->query( "SELECT * FROM `{$dbprefix}pages` WHERE `disabled`='0' AND `hidden`='0' ORDER BY `order` ASC" );
	if ( $result->num_rows > 0 ) {
		$Pages = array();
		while ( $row = $result->fetch_object() ) {
			$Pages[] = array(
				'ID'	=> $row->id,
				'TITLE'	=> $row->title,
				'PRETTY_NAME' => $row->pretty_name,
			);
		}
		$tpl->assign( 'PAGES_NUM', $result->num_rows );
		$tpl->assign( 'PAGES', $Pages );
		unset( $Pages );
		$result->free_result();
	}
	
	/**
	* Statistics
	*/
	if ( $econf[ 'stats_enabled' ] ) {
		$tpl->assign( 'STATS_CODE', $econf[ 'stats_code' ] );
	}
?>